<?php

/*
 * This file is part of Monsieur Biz' Search plugin for Sylius.
 *
 * (c) Monsieur Biz <sylius@monsieurbiz.com>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

declare(strict_types=1);

namespace MonsieurBiz\SyliusSearchPlugin\Twig\Extension;

use Twig\Extension\AbstractExtension;
use Twig\TwigFunction;

class CheckMethodExists extends AbstractExtension
{
    private array $bundles;

    public function __construct(array $bundles)
    {
        $this->bundles = $bundles;
    }

    public function getFunctions(): iterable
    {
        return [
            new TwigFunction('bundle_exists', [$this, 'bundleExists']),
        ];
    }

    public function bundleExists($bundle): bool
    {
        return \array_key_exists(
            $bundle,
            $this->bundles
        );
    }
}
